/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the CreateServiceAccount type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateServiceAccount{}

// CreateServiceAccount struct for CreateServiceAccount
type CreateServiceAccount struct {
	Id string `json:"id"`
	Name string `json:"name"`
	UserId string `json:"user_id"`
	Active bool `json:"active"`
	CreatedAt time.Time `json:"created_at"`
	Token string `json:"token"`
}

// NewCreateServiceAccount instantiates a new CreateServiceAccount object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateServiceAccount(id string, name string, userId string, active bool, createdAt time.Time, token string) *CreateServiceAccount {
	this := CreateServiceAccount{}
	this.Id = id
	this.Name = name
	this.UserId = userId
	this.Active = active
	this.CreatedAt = createdAt
	this.Token = token
	return &this
}

// NewCreateServiceAccountWithDefaults instantiates a new CreateServiceAccount object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateServiceAccountWithDefaults() *CreateServiceAccount {
	this := CreateServiceAccount{}
	return &this
}

// GetId returns the Id field value
func (o *CreateServiceAccount) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CreateServiceAccount) SetId(v string) {
	o.Id = v
}

// GetName returns the Name field value
func (o *CreateServiceAccount) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CreateServiceAccount) SetName(v string) {
	o.Name = v
}

// GetUserId returns the UserId field value
func (o *CreateServiceAccount) GetUserId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetUserIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserId, true
}

// SetUserId sets field value
func (o *CreateServiceAccount) SetUserId(v string) {
	o.UserId = v
}

// GetActive returns the Active field value
func (o *CreateServiceAccount) GetActive() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Active
}

// GetActiveOk returns a tuple with the Active field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetActiveOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Active, true
}

// SetActive sets field value
func (o *CreateServiceAccount) SetActive(v bool) {
	o.Active = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *CreateServiceAccount) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *CreateServiceAccount) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetToken returns the Token field value
func (o *CreateServiceAccount) GetToken() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Token
}

// GetTokenOk returns a tuple with the Token field value
// and a boolean to check if the value has been set.
func (o *CreateServiceAccount) GetTokenOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Token, true
}

// SetToken sets field value
func (o *CreateServiceAccount) SetToken(v string) {
	o.Token = v
}

func (o CreateServiceAccount) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateServiceAccount) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["name"] = o.Name
	toSerialize["user_id"] = o.UserId
	toSerialize["active"] = o.Active
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["token"] = o.Token
	return toSerialize, nil
}

type NullableCreateServiceAccount struct {
	value *CreateServiceAccount
	isSet bool
}

func (v NullableCreateServiceAccount) Get() *CreateServiceAccount {
	return v.value
}

func (v *NullableCreateServiceAccount) Set(val *CreateServiceAccount) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateServiceAccount) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateServiceAccount) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateServiceAccount(val *CreateServiceAccount) *NullableCreateServiceAccount {
	return &NullableCreateServiceAccount{value: val, isSet: true}
}

func (v NullableCreateServiceAccount) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateServiceAccount) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


